#include "framework.h"

#include <cmath> //for sqrt (square root) function

//**************************************
#ifdef WIN32
	#include <windows.h>
#else
	#include <sys/time.h>
#endif

long getTime()
{
	#ifdef WIN32
		return GetTickCount();
	#else
		struct timeval tv;
		gettimeofday(&tv,NULL);
		return (int)(tv.tv_sec*1000 + (tv.tv_usec / 1000));
	#endif
}

// **************************************

Point::Point()
{
	x = y = z = 0.0f;
}

Point::Point(float x, float y, float z)
{
	this->x = x;
	this->y = y;
	this->z = z;
}

void Point::Random(float range)
{
	//rand returns a value between 0 and RAND_MAX
	x = (rand() / (double)RAND_MAX) * 2 * range - range; //value between -range and range
	y = (rand() / (double)RAND_MAX) * 2 * range - range; //value between -range and range
	z = (rand() / (double)RAND_MAX) * 2 * range - range; //value between -range and range
}

//***********************************

Line::Line(Point a, Point b)
{
	start = a;
	end = b;
}

float Line::Lenght()
{
	//pitagoras
	return sqrt( (end.x - start.x) * (end.x - start.x) + (end.y - start.y) * (end.y - start.y) );
}

//Fill this function
std::vector<Point> Line::CalculePointsUsingBresenham()
{
	std::vector<Point> result;

	//add the first point
	result.push_back( start );

	//Bresenham algorythm
	//...

	//add the last point
	result.push_back( end );

	return result;
}

std::vector<Point> Line::CalculePointsUsingDDA()
{
	std::vector<Point> result;

	//DDA algorythm
	//...

	return result;
}

//Cercle class
//...




